package mhtree;

import messif.objects.LocalAbstractObject;

public enum ObjectToNodeDistance {
    NEAREST_HULL_OBJECT {
        @Override
        public double getDistance(LocalAbstractObject object, Node node) {
            return node.getHullObjects().stream()
                    .mapToDouble(object::getDistance)
                    .min()
                    .orElse(Double.MAX_VALUE);
        }
    },
    FURTHEST_HULL_OBJECT {
        @Override
        public double getDistance(LocalAbstractObject object, Node node) {
            return node.getHullObjects().stream()
                    .mapToDouble(object::getDistance)
                    .max()
                    .orElse(Double.MIN_VALUE);
        }
    },
    AVERAGE_DISTANCE {
        @Override
        public double getDistance(LocalAbstractObject object, Node node) {
            return node.getHullObjects().stream()
                    .mapToDouble(object::getDistance)
                    .sum() / node.getHullObjects().size();
        }
    };

    public abstract double getDistance(LocalAbstractObject object, Node node);
}
